VERSION 5.00
Begin VB.Form frmNES 
   BackColor       =   &H80000000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   4365
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   4335
   Icon            =   "frmNES.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4365
   ScaleWidth      =   4335
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox picScreen 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000001&
      ForeColor       =   &H80000008&
      Height          =   3615
      Left            =   240
      ScaleHeight     =   239
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   255
      TabIndex        =   0
      Top             =   240
      Width           =   3855
   End
   Begin VB.Label lblStatus 
      BackColor       =   &H80000004&
      Caption         =   "Frames: 0"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   4080
      Width           =   4335
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileLoad 
         Caption         =   "&Load ROM"
         Shortcut        =   ^L
      End
      Begin VB.Menu mnuFileFree 
         Caption         =   "&Free ROM"
         Shortcut        =   ^F
      End
      Begin VB.Menu mnuHyphen 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
         Shortcut        =   ^X
      End
   End
   Begin VB.Menu mnuEmulation 
      Caption         =   "&Emulation"
      Begin VB.Menu mnuFrameSkip 
         Caption         =   "Frame Skip"
         Begin VB.Menu mnuFS 
            Caption         =   "Draw All Frames"
            Index           =   0
         End
         Begin VB.Menu mnuFS 
            Caption         =   "1"
            Index           =   1
         End
         Begin VB.Menu mnuFS 
            Caption         =   "2"
            Index           =   2
         End
         Begin VB.Menu mnuFS 
            Caption         =   "3"
            Index           =   3
         End
      End
      Begin VB.Menu mnuCPUPause 
         Caption         =   "&Pause CPU"
      End
      Begin VB.Menu mnuEmuReset 
         Caption         =   "&Reset CPU"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "frmNES"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Function open_file() As String
    
    Dim lReturn As Long
    Dim sFilter As String
    OpenFile.lStructSize = Len(OpenFile)
    OpenFile.hwndOwner = Me.hWnd
    OpenFile.hInstance = App.hInstance
    sFilter = "NES ROMs (*.nes)" & Chr(0) & "*.nes" & Chr(0) & "All Files (*.*)" & Chr(0) & "*.*" & Chr(0)
    OpenFile.lpstrFilter = sFilter
    OpenFile.nFilterIndex = 1
    OpenFile.lpstrFile = String(257, 0)
    OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
    OpenFile.lpstrFileTitle = OpenFile.lpstrFile
    OpenFile.nMaxFileTitle = OpenFile.nMaxFile
    OpenFile.lpstrInitialDir = InitDirectory & "\"
    OpenFile.lpstrTitle = "Open *.NES ROM"
    OpenFile.flags = 4
    lReturn = GetOpenFileName(OpenFile)
    If lReturn = 0 Then
       open_file = ""
    Else
       open_file = OpenFile.lpstrFile
    End If
End Function
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Keyboard(KeyCode) = &H41
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
Keyboard(KeyCode) = &H41
End Sub

Private Sub Form_Load()
Caption = VERSION
CPUPaused = False
frmNES.mnuCPUPause.Checked = False
Show
LoadPal
Table = Array(1, 2, 4, 8, 16, 32, 64, 128)
End Sub

Private Sub Form_Unload(Cancel As Integer)
Cancel = True
mnuFileExit_Click
End Sub
Private Sub mnuCPUPause_Click()
If CPUPaused = False Then
    CPUPaused = True
    mnuCPUPause.Checked = True
Else
    CPUPaused = False
    mnuCPUPause.Checked = False
End If
End Sub
Private Sub mnuEmuReset_Click()
    Select Case Mapper
        Case 0, 3
            Select8KVROM 0
            reg8 = 0: regA = 1: regC = &HFE: regE = &HFF
            SetupBanks
        Case 1
            Select8KVROM 0
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
            sequence = 0: accumulator = 0
            Erase data
            data(0) = &H1F: data(3) = 0
        Case 2
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 4
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
            MMC3_IrqOn = False
            MMC3_IrqVal = 0
            MMC3_TmpVal = 0
            If ChrCount Then Select8KVROM 0
        Case 7
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
        Case 8 'FFE F3xxx
            reg8 = 0: regA = 1
            regC = &HFE: regE = &HFF
            SetupBanks
            Select8KVROM 0
        Case 9 ' MMC2
            reg8 = 0
            regA = &HFD
            regC = &HFE
            regE = &HFF
            SetupBanks
            latch1.hi_bank = 0: latch1.lo_bank = 0: latch1.state = 0
            latch2.hi_bank = 0: latch2.lo_bank = 0: latch2.state = 0
            Select8KVROM 0
        Case 11
            reg8 = 0: regA = 1: regC = 2: regE = 3
            SetupBanks
            Select8KVROM 0
        Case 15
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
        Case 16
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 32
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 33
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 34
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
            If ChrCount Then Select8KVROM 0
        Case 40 ' SMB2j [works!]
            Dim ChoseIt As Byte
            ChoseIt = 6
            ChoseIt = MaskBankAddress(ChoseIt)
            Debug.Print ChoseIt
            UsesSRAM = True
            MemCopy bank6(0), gameImage(ChoseIt * &H2000&), &H2000&
            reg8 = &HFC
            regA = &HFD
            regC = &HFE
            regE = &HFF
            SetupBanks
            Select8KVROM 0
            Mapper40_IRQEnabled = 0
            Mapper40_IRQCounter = 0
        Case 66
            reg8 = 0: regA = 1: regC = 2: regE = 3: SetupBanks
            Select8KVROM 0
        Case 91
            reg8 = &HFE
            regA = &HFF
            regC = &HFE
            regE = &HFF
            Select8KVROM 0
            SetupBanks
    End Select
    Debug.Print "Successfully loaded " & filename
    reset6502
    If Mirroring = 1 Then MirrorXor = &H800& Else MirrorXor = &H400&
    Debug.Print "Reset from menu"
End Sub

Private Sub mnuFileExit_Click()
Erase gameImage, VROM, VRAM, bank0, bank6, bank8, bankA, bankC, bankE
End
End Sub

Private Sub mnuFileFree_Click()
' Erase all known content of rom.
Erase VRAM: Erase gameImage: Erase bank0: Erase bank6
Erase VROM: Erase SpriteRAM: Erase Joypad1
Erase bank8: Erase bankA: Erase bankC: Erase bankE
picScreen.Cls
CPURunning = False
End Sub

Private Sub mnuFileLoad_Click()
Dim filename As String
filename = open_file()
CPUPaused = False
If filename = "" Then Exit Sub
If LoadNES(filename) = 0 Then Exit Sub
Dim NESLoop As Integer
CPURunning = True
FirstRead = True
PPU_AddressIsHi = True
PPUAddress = 0: SpriteAddress = 0: PPU_Status = 0
PPU_Control1 = 0: PPU_Control2 = 0
init6502
mnuFS_Click (0)
Do Until CPURunning = False
    exec6502
Loop
End Sub

Private Sub mnuFS_Click(Index As Integer)
FrameSkip = Index + 1
For i = 0 To mnuFS.UBound
    mnuFS(i).Checked = False
Next i
mnuFS(Index).Checked = True
End Sub

Private Sub mnuHelpAbout_Click()
Dim Message As String
Message = VERSION & vbCrLf
Message = Message & vbCrLf & "By Don Jarrett, 2000" & vbCrLf
Message = Message & "http://home.att.net/~r.jarrett/bNES.html" & vbCrLf & vbCrLf
Message = Message & "Some mapper code is courtesy of DarcNES and Pretendo." & vbCrLf & "Thanks to both nyef and Delta for the information." & vbCrLf
Message = Message & "Open File Dialog code courtesy Matthew Leverton." & vbCrLf
Message = Message & "Line based rendering ideas courtesy of Lothos." & vbCrLf
Message = Message & "Palette code ideas by Bero of FCE." & vbCrLf & vbCrLf
Message = Message & "I do not advocate the piracy of Nintendo ROMs." & vbCrLf & vbCrLf
Message = Message & "Support Nester! at http://nester.homepage.com" & vbCrLf & vbCrLf
Message = Message & "basicNES is Copyright (C) 1996-2000 Don Jarrett"
MsgBox Message, 64, VERSION
End Sub

Private Sub picScreen_KeyDown(KeyCode As Integer, Shift As Integer)
Keyboard(KeyCode) = &H41
End Sub

Private Sub picScreen_KeyUp(KeyCode As Integer, Shift As Integer)
Keyboard(KeyCode) = &H40
End Sub
